## mongodb 6.1.1

=== SConstruct ===
# -*- mode: python; -*-

import atexit
import copy
import errno
import functools
import json
import os
import re
import platform
import shlex
import shutil
import stat
import subprocess
import sys
import textwrap
import uuid
from glob import glob

from pkg_resources import parse_version

import SCons
import SCons.Script

# This must be first, even before EnsureSConsVersion, if
# we are to avoid bulk loading all tools in the DefaultEnvironment.
DefaultEnvironment(tools=[])

# These come from site_scons/mongo. Import these things
# after calling DefaultEnvironment, for the sake of paranoia.
import mongo
import mongo.platform as mongo_platform
import mongo.toolchain as mongo_toolchain
import mongo.generators as mongo_generators
import mongo.install_actions as install_actions
from mongo.build_profiles import BUILD_PROFILES

EnsurePythonVersion(3, 6)
EnsureSConsVersion(3, 1, 1)


# Monkey patch SCons.FS.File.release_target_info to be a no-op.
# See https://github.com/SCons/scons/issues/3454
def release_target_info_noop(self):
    pass


SCons.Node.FS.File.release_target_info = release_target_info_noop

from buildscripts import utils
from buildscripts import moduleconfig

import psutil

scons_invocation = '{} {}'.format(sys.executable, ' '.join(sys.argv))
print('scons: running with args {}'.format(scons_invocation))

atexit.register(mongo.print_build_failures)

# An extra instance of the SCons parser is used to manually validate options
# flags. We use it detect some common misspellings/unknown options and
# communicate with the user more effectively than just allowing Configure to
# fail.
# This is to work around issue #4187
# (https://github.com/SCons/scons/issues/4187). Upon a future upgrade to SCons
# that incorporates #4187, we should replace this solution with that.
_parser = SCons.Script.SConsOptions.Parser("")


def add_option(name, **kwargs):
    _parser.add_option('--' + name, **{"default": None, **kwargs})

    if 'dest' not in kwargs:
        kwargs['dest'] = name

    if 'metavar' not in kwargs and kwargs.get('type', None) == 'choice':
        kwargs['metavar'] = '[' + '|'.join(kwargs['choices']) + ']'

    AddOption('--' + name, **kwargs)


def get_option(name):
    return GetOption(name)


def has_option(name):
    optval = GetOption(name)
    # Options with nargs=0 are true when their value is the empty tuple. Otherwise,
    # if the value is falsish (empty string, None, etc.), coerce to False.
    return True if optval == () else bool(optval)


def use_system_version_of_library(name):
    return has_option('use-system-all') or has_option('use-system-' + name)


# Returns true if we have been configured to use a system version of any C++ library. If you
# add a new C++ library dependency that may be shimmed out to the system, add it to the below
# list.
def using_system_version_of_cxx_libraries():
    cxx_library_names = ["tcmalloc", "boost"]
    return True in [use_system_version_of_library(x) for x in cxx_library_names]


def make_variant_dir_generator():
    memoized_variant_dir = [False]

    def generate_variant_dir(target, source, env, for_signature):
        if not memoized_variant_dir[0]:
            memoized_variant_dir[0] = env.subst('$BUILD_ROOT/$VARIANT_DIR')
        return memoized_variant_dir[0]

    return generate_variant_dir


# Always randomize the build order to shake out missing edges, and to help the cache:
# http://scons.org/doc/production/HTML/scons-user/ch24s06.html
SetOption('random', 1)

# Options TODOs:
#
# - We should either alphabetize the entire list of options, or split them into logical groups
#   with clear boundaries, and then alphabetize the groups. There is no way in SCons though to
#   inform it of options groups.
#
# - Many of these options are currently only either present or absent. This is not good for
#   scripting the build invocation because it means you need to interpolate in the presence of
#   the whole option. It is better to make all options take an optional on/off or true/false
#   using the nargs='const' mechanism.
#

add_option(
    'build-profile',
    choices=list(BUILD_PROFILES.keys()),
    default='default',
    type='choice',
    help='''Short hand for common build configurations. These profiles are well supported by the build
    and are kept up to date. The 'default' profile should be used unless you have the required
    prerequisites in place to use the other profiles, i.e. having the mongodbtoolchain installed
    and being connected to an icecream cluster. For mongodb developers, it is recommended to use
    the 'san' (sanitizer) profile to identify bugs as soon as possible. Check out
    site_scons/mongo/build_profiles.py to see each profile.''',
)

build_profile = BUILD_PROFILES[get_option('build-profile')]

add_option(
    'ninja',
    choices=['enabled', 'disabled'],
    default=build_profile.ninja,
    nargs='?',
    const='enabled',
    type='choice',
    help='Enable the build.ninja generator tool stable or canary version',
)

add_option(
    'force-jobs',
    help='Allow more jobs than available cpu\'s when icecream is not enabled.',
    nargs=0,
)

add_option(
    'build-tools',
    choices=['stable', 'next'],
    default='stable',
    type='choice',
    help='Enable experimental build tools',
)

add_option(
    'legacy-tarball',
    choices=['true', 'false'],
    default='false',
    const='true',
    nargs='?',
    type='choice',
    help='Build a tarball matching the old MongoDB dist targets',
)

add_option(
    'lint-scope',
    choices=['all', 'changed'],
    default='all',
    type='choice',
    help='Lint files in the current git diff instead of all files',
)

add_option(
    'install-mode',
    choices=['hygienic'],
    default='hygienic',
    help='select type of installation',
    nargs=1,
    type='choice',
)

add_option(
    'install-action',
    choices=([*install_actions.available_actions] + ['default']),
    default='hardlink',
    help=
    'select mechanism to use to install files (advanced option to reduce disk IO and utilization)',
    nargs=1,
    type='choice',
)

add_option(
    'build-dir',
    default='#build',
    help='build output directory',
)

add_option(
    'release',
    help='release build',
    nargs=0,
)

add_option(
    'lto',
    help='enable link time optimizations (experimental, except with MSVC)',
    nargs=0,
)

add_option(
    'endian',
    choices=['big', 'little', 'auto'],
    default='auto',
    help='endianness of target platform',
    nargs=1,
    type='choice',
)

add_option(
    'disable-minimum-compiler-version-enforcement',
    help='allow use of unsupported older compilers (NEVER for production builds)',
    nargs=0,
)

add_option(
    'ssl',
    help='Enable or Disable SSL',
    choices=['on', 'off'],
    default='on',
    const='on',
    nargs='?',
    type='choice',
)

add_option(
    'wiredtiger',
    choices=['on', 'off'],
    const='on',
    default='on',
    help='Enable wiredtiger',
    nargs='?',
    type='choice',
)

add_option(
    'ocsp-stapling',
    choices=['on', 'off'],
    default='on',
    help='Enable OCSP Stapling on servers',
    nargs='?',
    type='choice',
)

js_engine_choices = ['mozjs', 'none']
add_option(
    'js-engine',
    choices=js_engine_choices,
    default=js_engine_choices[0],
    help='JavaScript scripting engine implementation',
    type='choice',
)

add_option(
    'server-js',
    choices=['on', 'off'],
    default='on',
    help='Build mongod without JavaScript support',
    type='choice',
)

add_option(
    'libc++',
    help='use libc++ (experimental, requires clang)',
    nargs=0,
)

add_option(
    'use-glibcxx-debug',
    help='Enable the glibc++ debug implementations of the C++ standard libary',
    nargs=0,
)

add_option(
    'noshell',
    help="don't build shell",
    nargs=0,
)

add_option(
    'dbg',
    choices=['on', 'off'],
    const='on',
    default=build_profile.dbg,
    help='Enable runtime debugging checks',
    nargs='?',
    type='choice',
)

add_option(
    'disable-ref-track',
    help="Disables runtime tracking of REF state changes for pages within wiredtiger. "
    "Tracking the REF state changes is useful for debugging but there is a small performance cost.",
    nargs=0,
)

add_option(
    'separate-debug',
    choices=['on', 'off'],
    const='on',
    default='off',
    help='Produce separate debug files',
    nargs='?',
    type='choice',
)

add_option(
    'spider-monkey-dbg',
    choices=['on', 'off'],
    const='on',
    default='off',
    help='Enable SpiderMonkey debug mode',
    nargs='?',
    type='choice',
)

add_option(
    'opt',
    choices=['on', 'debug', 'size', 'off', 'auto'],
    const='on',
    default=build_profile.opt,
    help='Enable compile-time optimization',
    nargs='?',
    type='choice',
)

experimental_optimizations = [
    'O3',
    'builtin-memcmp',
    'fnsi',
    'nofp',
    'nordyn',
    'sandybridge',
    'tbaa',
    'treevec',
    'vishidden',
]
experimental_optimization_choices = ['*']
experimental_optimization_choices.extend("+" + opt for opt in experimental_optimizations)
experimental_optimization_choices.extend("-" + opt for opt in experimental_optimizations)

add_option(
    'experimental-optimization',
    action="append",
    choices=experimental_optimization_choices,
    const=experimental_optimization_choices[0],
    default=['+sandybridge'],
    help='Enable experimental optimizations',
    nargs='?',
    type='choice',
)

add_option(
    'debug-compress',
    action="append",
    choices=["off", "as", "ld"],
    default=["auto"],
    help="Compress debug sections",
)

add_option(
    'sanitize',
    help='enable selected sanitizers',
    metavar='san1,san2,...sanN',
    default=build_profile.sanitize,
)

add_option(
    'sanitize-coverage',
    help='enable selected coverage sanitizers',
    metavar='cov1,cov2,...covN',
)

add_option(
    'allocator',
    choices=["auto", "system", "tcmalloc", "tcmalloc-experimental"],
    default=build_profile.allocator,
    help='allocator to use (use "auto" for best choice for current platform)',
    type='choice',
)

add_option(
    'gdbserver',
    help='build in gdb server support',
    nargs=0,
)

add_option(
    'lldb-server',
    help='build in lldb server support',
    nargs=0,
)

add_option(
    'gcov',
    help='compile with flags for gcov',
    nargs=0,
)

add_option(
    'enable-free-mon',
    choices=["auto", "on", "off"],
    default="auto",
    help='Disable support for Free Monitoring to avoid HTTP client library dependencies',
    type='choice',
)

add_option(
    'enable-http-client',
    choices=["auto", "on", "off"],
    default="auto",
    help='Enable support for HTTP client requests (required WinHTTP or cURL)',
    type='choice',
)

add_option(
    'use-sasl-client',
    help='Support SASL authentication in the client library',
    nargs=0,
)

add_option(
    'use-diagnostic-latches',
    choices=['on', 'off'],
    default='on',
    help='Enable annotated Mutex types',
    type='choice',
)

# Most of the "use-system-*" options follow a simple form.
for pack in [
    (
        'asio',
        'ASIO',
    ),
    ('boost', ),
    ('fmt', ),
    ('google-benchmark', 'Google benchmark'),
    ('icu', 'ICU'),
    ('intel_decimal128', 'intel decimal128'),
    ('kms-message', ),
    ('pcre2', ),
    ('snappy', ),
    ('stemmer', ),
    ('tcmalloc', ),
    ('libunwind', ),
    ('valgrind', ),
    ('wiredtiger', ),
    ('yaml', ),
    ('zlib', ),
    ('zstd', 'Zstandard'),
]:
    name = pack[0]
    pretty = name
    if len(pack) == 2:
        pretty = pack[1]
    add_option(
        f'use-system-{name}',
        help=f'use system version of {pretty} library',
        nargs=0,
    )

add_option(
    'system-boost-lib-search-suffixes',
    help='Comma delimited sequence of boost library suffixes to search',
)

add_option(
    'use-system-mongo-c',
    choices=['on', 'off', 'auto'],
    const='on',
    default="auto",

=== debian/changelog ===
mongodb (1:6.1.1-0parrot1) lory; urgency=medium

  * Rebuild for Parrot 6.0.

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Thu, 07 Sep 2023 02:04:14 +0200

mongodb (1:6.1.1-0kali5) kali-dev; urgency=medium

  * Add more logs in case autopkgtests fail
  * Remove journal=true from config

 -- Arnaud Rebillout <arnaudr@kali.org>  Wed, 09 Aug 2023 16:45:32 +0700

mongodb (1:6.1.1-0kali4) kali-dev; urgency=medium

  * Update patch to fix arm64 build

 -- Arnaud Rebillout <arnaudr@kali.org>  Tue, 08 Aug 2023 21:50:54 +0700

mongodb (1:6.1.1-0kali3) kali-dev; urgency=medium

  * Add patch to fix build on arm64

 -- Arnaud Rebillout <arnaudr@kali.org>  Tue, 08 Aug 2023 14:55:39 +0700

mongodb (1:6.1.1-0kali2) kali-dev; urgency=medium

  * Use --max-parallel=4 to fix build on arm64

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 19 Jul 2023 08:55:27 +0200

mongodb (1:6.1.1-0kali1) kali-dev; urgency=medium

  [ Kali Janitor ]
  * Trim trailing whitespace.
  * debian/copyright: use spaces rather than tabs to start continuation lines.

  [ Steev Klimaszewski ]
  * Fix ftbfs with gcc 12 being more strict on arm64
  * ci: Don't build on 32bit architectures.
  * Drop dependency on lsb-base
  * d/watch: Update regex check for versions

  [ Sophie Brun ]
  * New upstream version 6.1.1
  * Refresh patches
  * Use pcre2 instead of prce

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 18 Jul 2023 11:20:34 +0200

mongodb (1:6.0.1-0kali2) kali-dev; urgency=medium

  * Add misssing build-dep liblzma-dev for arm64

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 28 Sep 2022 09:27:52 +0200

mongodb (1:6.0.1-0kali1) kali-dev; urgency=medium

  * New upstream version 6.0.1
  * Refresh patches
  * Import upstream patch to fix build failure
  * Update lintian-overrides
  * Update for the build for new upstream release

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 28 Sep 2022 08:25:47 +0200

mongodb (1:5.3.1-0kali1) kali-dev; urgency=medium

  * Update debian/watch for new upstream releases
  * New upstream version 5.3.1
  * d/control: Update for Kali
  * Refresh patches
  * Update debian/copyright
  * Update the build-deps
  * Add MONGO_VERSION to options for scons
  * Remove DEB_SCONS_OPTIONS += --nostrip (it does not exist)
  * Use --use-system-zstd to build the package
  * Use embedded scons
  * Remove useless patch
  * Update installation for mongodb-clients
  * Install only the required manpage
  * Install doc in usr/share/doc
  * Clean debian/rules
  * Update debian/copyright
  * Update lintian-overrides
  * Improve autopkgtest

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 13 Apr 2022 09:37:37 +0200

=== debian/control ===
Source: mongodb
Section: non-free/database
Priority: optional
Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Build-Depends:
 debhelper (>= 11~),
 libboost-date-time-dev,
 libboost-dev (>> 1.50),
 libboost-log-dev,
 libboost-filesystem-dev,
 libboost-iostreams-dev,
 libboost-program-options-dev,
 libboost-thread-dev,
 libboost-regex-dev,
 libgoogle-perftools-dev,
 liblzma-dev,
 libyaml-cpp-dev,
 libpcap-dev,
 libpcre2-dev,
 libreadline-dev,
 libsnappy-dev,
 libstemmer-dev,
 libcurl4-openssl-dev,
 libssl-dev,
 libzstd-dev,
 zlib1g-dev,
 python3-cheetah,
 python3-distutils,
 python3-packaging,
 python3-pkg-resources,
 python3-psutil,
 python3-pymongo,
 python3-yaml,
 python3,
# scons,
 tzdata,
 valgrind
Standards-Version: 4.2.1
Homepage: https://www.mongodb.org

Package: mongodb
Architecture: amd64 arm64
Depends: mongodb-server (>= 1:2.4.1-2), ${misc:Depends}, ${shlibs:Depends}
Description: object/document-oriented database (metapackage)
 MongoDB is a high-performance, open source, schema-free
 document-oriented data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features:
 .
    * Collection oriented storage - easy storage of object-style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large objects (e.g. videos)
    * Auto-sharding for cloud-level scalability
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This is a convenience metapackage that depends on all the mongodb parts:
 the server, the clients and the development files (headers and library).

Package: mongodb-server
Architecture: all
Depends:
 mongodb-clients,
 mongodb-server-core (>= ${source:Version}),
 mongodb-server-core (<< ${source:Version}.1~),
 adduser,
 ${misc:Depends},
Description: object/document-oriented database (managed server package)
 MongoDB is a high-performance, open source, schema-free
 document-oriented data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features:
 .
    * Collection oriented storage - easy storage of object-style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large objects (e.g. videos)
    * Auto-sharding for cloud-level scalability
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This package installs MongoDB as a system service.

Package: mongodb-server-core
Architecture: amd64 arm64
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks:
 mongodb-server (<< 1:3.4.14-1~)
Replaces:
 mongodb-server (<< 1:3.4.14-1~)
Description: object/document-oriented database (server binaries package)
 MongoDB is a high-performance, open source, schema-free
 document-oriented data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features:
 .
    * Collection oriented storage - easy storage of object-style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large objects (e.g. videos)
    * Auto-sharding for cloud-level scalability
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This package contains the database server (mongod) and sharding
 server/load-balancer (mongos) binaries.

Package: mongodb-clients
Architecture: amd64 arm64
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Recommends: mongo-tools
Replaces:
 mongodb (<= 1:1.4.2-2)
Description: object/document-oriented database (client apps)
 MongoDB is a high-performance, open source, schema-free
 document-oriented data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features:
 .
    * Collection oriented storage - easy storage of object-style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large objects (e.g. videos)
    * Auto-sharding for cloud-level scalability
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This package contains the standard administrative shell (mongo) and other
 utilities for administration or analysis of performance of the server.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk

# Use gcc and g++ by default, but allow setting them from the environment
CC ?= gcc
CXX ?= g++

DEB_SCONS_OPTIONS :=
ifneq (,$(filter debug,$(DEB_BUILD_OPTIONS)))
	DEB_SCONS_OPTIONS := --d=DEBUGBUILD
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
       PROCS=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
       DEB_SCONS_OPTIONS += -j$(PROCS)
endif

COMMON_OPTIONS = --use-system-tcmalloc \
		 --use-system-pcre2 \
		 --use-system-snappy \
		 --use-system-zlib --use-system-valgrind \
		 --use-system-stemmer --use-system-yaml \
		 --use-system-zstd \
		 --disable-warnings-as-errors \
		 --ssl $(DEB_SCONS_OPTIONS) \
		 MONGO_VERSION=$(DEB_VERSION_UPSTREAM) \
		 CC=$(CC) CXX=$(CXX)

gperftools_archs = amd64 arm64
ifneq (,$(filter $(DEB_HOST_ARCH), $(gperftools_archs)))
COMMON_OPTIONS += --allocator=tcmalloc
else
COMMON_OPTIONS += --allocator=system
endif

override_dh_auto_clean:
	python3 src/third_party/scons-3.1.2/scons.py --keep-going --clean $(COMMON_OPTIONS) .
	find $(CURDIR)/ -name "*.pyc" -delete
	rm -rf $(CURDIR)/.scons/
	rm -rf $(CURDIR)/build/

override_dh_auto_install:
	python3 src/third_party/scons-3.1.2/scons.py DESTDIR=debian/tmp/usr $(COMMON_OPTIONS) install-devcore

override_dh_installsystemd:
	dh_installsystemd -pmongodb-server --no-enable --name=mongodb

%:
	dh $@ --max-parallel=4

=== debian/tests/control ===
Tests: mongod basic
Depends: mongodb-server, mongodb-clients, procps
Restrictions: needs-root, isolation-container, breaks-testbed

## mongodb 7.0.14

=== SConstruct ===
--- 
+++ 
@@ -7,6 +7,7 @@
 import json
 import os
 import re
+import pathlib
 import platform
 import shlex
 import shutil
@@ -15,12 +16,15 @@
 import sys
 import textwrap
 import uuid
+from datetime import datetime
 from glob import glob
 
 from pkg_resources import parse_version
 
 import SCons
 import SCons.Script
+from mongo_tooling_metrics.lib.top_level_metrics import SConsToolingMetrics
+from site_scons.mongo import build_profiles
 
 # This must be first, even before EnsureSConsVersion, if
 # we are to avoid bulk loading all tools in the DefaultEnvironment.
@@ -33,10 +37,11 @@
 import mongo.toolchain as mongo_toolchain
 import mongo.generators as mongo_generators
 import mongo.install_actions as install_actions
-from mongo.build_profiles import BUILD_PROFILES
 
 EnsurePythonVersion(3, 6)
 EnsureSConsVersion(3, 1, 1)
+
+utc_starttime = datetime.utcnow()
 
 
 # Monkey patch SCons.FS.File.release_target_info to be a no-op.
@@ -49,7 +54,6 @@
 
 from buildscripts import utils
 from buildscripts import moduleconfig
-
 import psutil
 
 scons_invocation = '{} {}'.format(sys.executable, ' '.join(sys.argv))
@@ -131,8 +135,8 @@
 
 add_option(
     'build-profile',
-    choices=list(BUILD_PROFILES.keys()),
-    default='default',
+    choices=[type for type in build_profiles.BuildProfileType],
+    default=build_profiles.BuildProfileType.DEFAULT,
     type='choice',
     help='''Short hand for common build configurations. These profiles are well supported by the build
     and are kept up to date. The 'default' profile should be used unless you have the required
@@ -142,7 +146,7 @@
     site_scons/mongo/build_profiles.py to see each profile.''',
 )
 
-build_profile = BUILD_PROFILES[get_option('build-profile')]
+build_profile = build_profiles.get_build_profile(get_option('build-profile'))
 
 add_option(
     'ninja',
@@ -158,6 +162,12 @@
     'force-jobs',
     help='Allow more jobs than available cpu\'s when icecream is not enabled.',
     nargs=0,
+)
+
+add_option(
+    'extra_dist_files',
+    help=
+    'If defined, it should be a comma-delimited list of repository-relative paths to include in the dist target as installed files',
 )
 
 add_option(
@@ -423,14 +433,6 @@
 )
 
 add_option(
-    'enable-free-mon',
-    choices=["auto", "on", "off"],
-    default="auto",
-    help='Disable support for Free Monitoring to avoid HTTP client library dependencies',
-    type='choice',
-)
-
-add_option(
     'enable-http-client',
     choices=["auto", "on", "off"],
     default="auto",
@@ -447,7 +449,7 @@
 add_option(
     'use-diagnostic-latches',
     choices=['on', 'off'],
-    default='on',
+    default='off',
     help='Enable annotated Mutex types',
     type='choice',
 )
@@ -461,10 +463,13 @@
     ('boost', ),
     ('fmt', ),
     ('google-benchmark', 'Google benchmark'),
+    ('grpc', ),
     ('icu', 'ICU'),
     ('intel_decimal128', 'intel decimal128'),
-    ('kms-message', ),
+    ('libbson', ),
+    ('libmongocrypt', ),
     ('pcre2', ),
+    ('protobuf', "Protocol Buffers"),
     ('snappy', ),
     ('stemmer', ),
     ('tcmalloc', ),
@@ -486,12 +491,3 @@
     )
 
 add_option(
-    'system-boost-lib-search-suffixes',
-    help='Comma delimited sequence of boost library suffixes to search',
-)
-
-add_option(
-    'use-system-mongo-c',
-    choices=['on', 'off', 'auto'],
-    const='on',
-    default="auto",

=== src/third_party/abseil-cpp/dist/absl/flags/CMakeLists.txt ===
#
# Copyright 2019 The Abseil Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

# Internal-only target, do not depend on directly.
absl_cc_library(
  NAME
    flags_path_util
  HDRS
    "internal/path_util.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::config
    absl::strings
  PUBLIC
)

# Internal-only target, do not depend on directly.
absl_cc_library(
  NAME
    flags_program_name
  SRCS
    "internal/program_name.cc"
  HDRS
    "internal/program_name.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::config
    absl::core_headers
    absl::flags_path_util
    absl::strings
    absl::synchronization
  PUBLIC
)

absl_cc_library(
  NAME
    flags_config
  SRCS
    "usage_config.cc"
  HDRS
    "config.h"
    "usage_config.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::config
    absl::flags_path_util
    absl::flags_program_name
    absl::core_headers
    absl::strings
    absl::synchronization
)

absl_cc_library(
  NAME
    flags_marshalling
  SRCS
    "marshalling.cc"
  HDRS
    "marshalling.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::config
    absl::core_headers
    absl::log_severity
    absl::strings
    absl::str_format
)

# Internal-only target, do not depend on directly.
absl_cc_library(
  NAME
    flags_commandlineflag_internal
  SRCS
    "internal/commandlineflag.cc"
  HDRS
    "internal/commandlineflag.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::config
    absl::fast_type_id
)

absl_cc_library(
  NAME
    flags_commandlineflag
  SRCS
    "commandlineflag.cc"
  HDRS
    "commandlineflag.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::config
    absl::fast_type_id
    absl::flags_commandlineflag_internal
    absl::optional
    absl::strings
)

# Internal-only target, do not depend on directly.
absl_cc_library(
  NAME
    flags_private_handle_accessor
  SRCS
    "internal/private_handle_accessor.cc"
  HDRS
    "internal/private_handle_accessor.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::config
    absl::flags_commandlineflag
    absl::flags_commandlineflag_internal
    absl::strings
)

absl_cc_library(
  NAME
    flags_reflection
  SRCS
    "reflection.cc"
  HDRS
    "reflection.h"
    "internal/registry.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::config
    absl::flags_commandlineflag
    absl::flags_private_handle_accessor
    absl::flags_config
    absl::strings
    absl::synchronization
    absl::flat_hash_map
)

# Internal-only target, do not depend on directly.
absl_cc_library(
  NAME
    flags_internal
  SRCS
    "internal/flag.cc"
  HDRS
    "internal/flag.h"
    "internal/sequence_lock.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::base
    absl::config
    absl::flags_commandlineflag
    absl::flags_commandlineflag_internal
    absl::flags_config
    absl::flags_marshalling
    absl::synchronization
    absl::meta
    absl::utility
  PUBLIC
)

absl_cc_library(
  NAME
    flags
  SRCS
    "flag.cc"
  HDRS
    "declare.h"
    "flag.h"
    "internal/flag_msvc.inc"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::config
    absl::flags_commandlineflag
    absl::flags_config
    absl::flags_internal
    absl::flags_reflection
    absl::base
    absl::core_headers
    absl::strings
)

# Internal-only target, do not depend on directly.
absl_cc_library(
  NAME
    flags_usage_internal
  SRCS
    "internal/usage.cc"
  HDRS
    "internal/usage.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::config
    absl::flags_config
    absl::flags
    absl::flags_commandlineflag
    absl::flags_internal
    absl::flags_path_util
    absl::flags_private_handle_accessor
    absl::flags_program_name
    absl::flags_reflection
    absl::flat_hash_map
    absl::strings
    absl::synchronization
)

absl_cc_library(
  NAME
    flags_usage
  SRCS
    "usage.cc"
  HDRS
    "usage.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::config
    absl::core_headers
    absl::flags_usage_internal
    absl::strings
    absl::synchronization
)

absl_cc_library(
  NAME
    flags_parse
  SRCS
    "parse.cc"
  HDRS
    "internal/parse.h"
    "parse.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  LINKOPTS
    ${ABSL_DEFAULT_LINKOPTS}
  DEPS
    absl::config
    absl::core_headers
    absl::flags_config
    absl::flags
    absl::flags_commandlineflag
    absl::flags_commandlineflag_internal
    absl::flags_internal
    absl::flags_private_handle_accessor
    absl::flags_program_name
    absl::flags_reflection
    absl::flags_usage
    absl::strings
    absl::synchronization
)

############################################################################
# Unit tests in alpahabetical order.

absl_cc_test(
  NAME
    flags_commandlineflag_test
  SRCS
    "commandlineflag_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::flags
    absl::flags_commandlineflag
    absl::flags_commandlineflag_internal
    absl::flags_config
    absl::flags_private_handle_accessor
    absl::flags_reflection
    absl::memory
    absl::strings
    GTest::gtest_main
)

absl_cc_test(
  NAME
    flags_config_test
  SRCS
    "config_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::flags_config
    GTest::gtest_main
)

absl_cc_test(
  NAME
    flags_flag_test
  SRCS
    "flag_test.cc"
    "flag_test_defs.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::core_headers
    absl::flags
    absl::flags_config
    absl::flags_internal
    absl::flags_marshalling
    absl::flags_reflection
    absl::strings
    absl::time
    GTest::gtest_main
)

absl_cc_test(
  NAME
    flags_marshalling_test
  SRCS
    "marshalling_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::flags_marshalling
    GTest::gtest_main
)

absl_cc_test(
  NAME
    flags_parse_test
  SRCS
    "parse_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::flags
    absl::flags_parse
    absl::flags_reflection
    absl::flags_usage_internal
    absl::raw_logging_internal
    absl::scoped_set_env
    absl::span
    absl::strings
    GTest::gmock_main
)

absl_cc_test(
  NAME
    flags_path_util_test
  SRCS
    "internal/path_util_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::flags_path_util
    GTest::gtest_main
)

absl_cc_test(
  NAME
    flags_program_name_test
  SRCS
    "internal/program_name_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::flags_program_name
    absl::strings
    GTest::gtest_main
)

absl_cc_test(
  NAME
    flags_reflection_test
  SRCS
    "reflection_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::flags_commandlineflag_internal
    absl::flags
    absl::flags_reflection
    absl::flags_usage
    absl::memory
    absl::strings
    GTest::gmock_main
)

absl_cc_test(
  NAME
    flags_sequence_lock_test
  SRCS
    "internal/sequence_lock_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::base
    absl::flags_internal
    absl::time
    GTest::gmock_main
)

absl_cc_test(
  NAME
    flags_usage_config_test
  SRCS
    "usage_config_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::flags_config
    absl::flags_path_util
    absl::flags_program_name
    absl::strings
    GTest::gtest_main
)

absl_cc_test(
  NAME
    flags_usage_test
  SRCS
    "internal/usage_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::flags_config
    absl::flags
    absl::flags_path_util
    absl::flags_program_name
    absl::flags_parse
    absl::flags_reflection
    absl::flags_usage
    absl::strings
    GTest::gtest
)

=== src/third_party/abseil-cpp/dist/absl/hash/CMakeLists.txt ===
#
# Copyright 2018 The Abseil Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

absl_cc_library(
  NAME
    hash
  HDRS
    "hash.h"
  SRCS
    "internal/hash.cc"
    "internal/hash.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
    DEPS
    absl::city
    absl::config
    absl::core_headers
    absl::endian
    absl::fixed_array
    absl::meta
    absl::int128
    absl::strings
    absl::optional
    absl::variant
    absl::utility
    absl::low_level_hash
  PUBLIC
)

absl_cc_library(
  NAME
    hash_testing
  HDRS
    "hash_testing.h"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::spy_hash_state
    absl::meta
    absl::strings
    absl::variant
    GTest::gmock
  TESTONLY
)

absl_cc_test(
  NAME
    hash_test
  SRCS
    "hash_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::cord_test_helpers
    absl::hash
    absl::hash_testing
    absl::core_headers
    absl::flat_hash_set
    absl::spy_hash_state
    absl::meta
    absl::int128
    GTest::gmock_main
)

absl_cc_library(
  NAME
    spy_hash_state
  HDRS
    "internal/spy_hash_state.h"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::hash
    absl::strings
    absl::str_format
  TESTONLY
)

absl_cc_library(
  NAME
    city
  HDRS
    "internal/city.h"
  SRCS
    "internal/city.cc"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::config
    absl::core_headers
    absl::endian
)

absl_cc_test(
  NAME
    city_test
  SRCS
    "internal/city_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::city
    GTest::gmock_main
)

absl_cc_library(
  NAME
    low_level_hash
  HDRS
    "internal/low_level_hash.h"
  SRCS
    "internal/low_level_hash.cc"
  COPTS
    ${ABSL_DEFAULT_COPTS}
  DEPS
    absl::bits
    absl::config
    absl::endian
    absl::int128
)

absl_cc_test(
  NAME
    low_level_hash_test
  SRCS
    "internal/low_level_hash_test.cc"
  COPTS
    ${ABSL_TEST_COPTS}
  DEPS
    absl::low_level_hash
    absl::strings
    GTest::gmock_main
)

=== src/third_party/grpc/dist/examples/cpp/route_guide/Makefile ===
#
# Copyright 2015 gRPC authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

HOST_SYSTEM = $(shell uname | cut -f 1 -d_)
SYSTEM ?= $(HOST_SYSTEM)
CXX = g++
CPPFLAGS += `pkg-config --cflags protobuf grpc`
CXXFLAGS += -std=c++11
ifeq ($(SYSTEM),Darwin)
LDFLAGS += -L/usr/local/lib `pkg-config --libs protobuf grpc++`\
					 -pthread\
           -lgrpc++_reflection\
           -ldl
else
LDFLAGS += -L/usr/local/lib `pkg-config --libs protobuf grpc++`\
           -pthread\
           -Wl,--no-as-needed -lgrpc++_reflection -Wl,--as-needed\
           -ldl
endif
PROTOC = protoc
GRPC_CPP_PLUGIN = grpc_cpp_plugin
GRPC_CPP_PLUGIN_PATH ?= `which $(GRPC_CPP_PLUGIN)`

PROTOS_PATH = ../../protos

vpath %.proto $(PROTOS_PATH)

all: system-check route_guide_client route_guide_server

route_guide_client: route_guide.pb.o route_guide.grpc.pb.o route_guide_client.o helper.o
	$(CXX) $^ $(LDFLAGS) -o $@

route_guide_server: route_guide.pb.o route_guide.grpc.pb.o route_guide_server.o helper.o
	$(CXX) $^ $(LDFLAGS) -o $@

%.grpc.pb.cc: %.proto
	$(PROTOC) -I $(PROTOS_PATH) --grpc_out=. --plugin=protoc-gen-grpc=$(GRPC_CPP_PLUGIN_PATH) $<

%.pb.cc: %.proto
	$(PROTOC) -I $(PROTOS_PATH) --cpp_out=. $<

clean:
	rm -f *.o *.pb.cc *.pb.h route_guide_client route_guide_server


# The following is to test your system and ensure a smoother experience.
# They are by no means necessary to actually compile a grpc-enabled software.

PROTOC_CMD = which $(PROTOC)
PROTOC_CHECK_CMD = $(PROTOC) --version | grep -q libprotoc.3
PLUGIN_CHECK_CMD = which $(GRPC_CPP_PLUGIN)
HAS_PROTOC = $(shell $(PROTOC_CMD) > /dev/null && echo true || echo false)
ifeq ($(HAS_PROTOC),true)
HAS_VALID_PROTOC = $(shell $(PROTOC_CHECK_CMD) 2> /dev/null && echo true || echo false)
endif
HAS_PLUGIN = $(shell $(PLUGIN_CHECK_CMD) > /dev/null && echo true || echo false)

SYSTEM_OK = false
ifeq ($(HAS_VALID_PROTOC),true)
ifeq ($(HAS_PLUGIN),true)
SYSTEM_OK = true
endif
endif

system-check:
ifneq ($(HAS_VALID_PROTOC),true)
	@echo " DEPENDENCY ERROR"
	@echo
	@echo "You don't have protoc 3.0.0 installed in your path."
	@echo "Please install Google protocol buffers 3.0.0 and its compiler."
	@echo "You can find it here:"
	@echo
	@echo "   https://github.com/protocolbuffers/protobuf/releases/tag/v3.0.0"
	@echo
	@echo "Here is what I get when trying to evaluate your version of protoc:"
	@echo
	-$(PROTOC) --version
	@echo
	@echo
endif
ifneq ($(HAS_PLUGIN),true)
	@echo " DEPENDENCY ERROR"
	@echo
	@echo "You don't have the grpc c++ protobuf plugin installed in your path."
	@echo "Please install grpc. You can find it here:"
	@echo
	@echo "   https://github.com/grpc/grpc"
	@echo
	@echo "Here is what I get when trying to detect if you have the plugin:"
	@echo
	-which $(GRPC_CPP_PLUGIN)
	@echo
	@echo
endif
ifneq ($(SYSTEM_OK),true)
	@false
endif

=== debian/changelog ===
mongodb (1:7.0.14-0kali3) kali-dev; urgency=medium

  * ci: Use even larger builders
  * ci: Give up on the arm64 build
  * Try to fix debian/tests/basic
  * ci: Also disable reprotest (takes too long)

 -- Arnaud Rebillout <arnaudr@kali.org>  Thu, 10 Oct 2024 20:35:15 +0700

mongodb (1:7.0.14-0kali2) kali-dev; urgency=medium

  * Revert Use --max-parallel=4 to fix build on arm64
  * Reduce the number of parallel jobs for arm64 builds

 -- Arnaud Rebillout <arnaudr@kali.org>  Wed, 09 Oct 2024 21:03:17 +0700

mongodb (1:7.0.14-0kali1) kali-dev; urgency=medium

  * New upstream version 7.0.14

 -- Arnaud Rebillout <arnaudr@kali.org>  Wed, 09 Oct 2024 09:03:38 +0700

mongodb (1:7.0.12-0kali1) kali-dev; urgency=medium

  [ Steev Klimaszewski ]
  * d/upstream: Add upstream metadata

  [ Sophie Brun ]
  * Remove obsolete build-dep python3-distutils
  * New upstream version 7.0.12
  * Refresh patches
  * Adapt for Python 3.12
  * Remove calculate_tooling_metrics
  * Add missing --linker=gold

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 13 Aug 2024 14:13:49 +0200

mongodb (1:6.1.1-0kali6) kali-dev; urgency=medium

  * ci: Use large builder on amd64.
  * ci: Use large build for -all and -any builds too.
  * ci: Increase arm64 timeout to 4 hours.
  * Revert "ci: Increase arm64 timeout to 4 hours."
  * Bump version for dependency bump.

 -- Steev Klimaszewski <steev@kali.org>  Wed, 11 Oct 2023 23:55:13 -0500

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: mongodb
 Section: non-free/database
 Priority: optional
-Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
-Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
+Maintainer: Kali Developers <devel@kali.org>
+Uploaders: Sophie Brun <sophie@offensive-security.com>
 Build-Depends:
  debhelper (>= 11~),
  libboost-date-time-dev,
@@ -16,7 +16,7 @@
  libgoogle-perftools-dev,
  liblzma-dev,
  libyaml-cpp-dev,
- libpcap-dev,
+ libpcap0.8-dev,
  libpcre2-dev,
  libreadline-dev,
  libsnappy-dev,
@@ -26,7 +26,6 @@
  libzstd-dev,
  zlib1g-dev,
  python3-cheetah,
- python3-distutils,
  python3-packaging,
  python3-pkg-resources,
  python3-psutil,
@@ -37,6 +36,8 @@
  tzdata,
  valgrind
 Standards-Version: 4.2.1
+Vcs-Git: https://gitlab.com/kalilinux/packages/mongodb.git
+Vcs-Browser: https://gitlab.com/kalilinux/packages/mongodb
 Homepage: https://www.mongodb.org
 
 Package: mongodb

=== debian/rules ===
--- 
+++ 
@@ -16,8 +16,13 @@
 endif
 
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
-       PROCS=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
-       DEB_SCONS_OPTIONS += -j$(PROCS)
+	PROCS=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
+# Kali: arm64 build failed so we reduced the number of parallel jobs
+ifeq ($(DEB_BUILD_ARCH),arm64)
+	DEB_SCONS_OPTIONS += -j$(shell expr $(PROCS) / 2)
+else
+	DEB_SCONS_OPTIONS += -j$(PROCS)
+endif
 endif
 
 COMMON_OPTIONS = --use-system-tcmalloc \
@@ -27,6 +32,7 @@
 		 --use-system-stemmer --use-system-yaml \
 		 --use-system-zstd \
 		 --disable-warnings-as-errors \
+		 --linker=gold \
 		 --ssl $(DEB_SCONS_OPTIONS) \
 		 MONGO_VERSION=$(DEB_VERSION_UPSTREAM) \
 		 CC=$(CC) CXX=$(CXX)
@@ -51,4 +57,4 @@
 	dh_installsystemd -pmongodb-server --no-enable --name=mongodb
 
 %:
-	dh $@ --max-parallel=4
+	dh $@

=== debian/watch ===
version=4
opts=uversionmangle=s/(\d)-(rc\d+)$/$1~$2/ \
     https://github.com/mongodb/mongo/tags \
             (?:.*?/)?r?(\d+\.\d+\.\d+(?!rc\d+))\.tar\.gz
#	https://www.mongodb.org/dl/src/ .*/mongodb-src-r(\d\.\d\..*)\.tar\.gz

## mongodb exporter-0.39.0

=== Makefile ===
.PHONY: all build clean default help init test format check-license
default: help

GO_TEST_PATH ?= ./...
GO_TEST_EXTRA ?=
GO_TEST_COVER_PROFILE ?= cover.out
GO_TEST_CODECOV ?=

BUILD ?= $(shell date +%FT%T%z)
GOVERSION ?= $(shell go version | cut -d " " -f3)
COMPONENT_VERSION ?= $(shell git describe --abbrev=0 --always)
COMPONENT_BRANCH ?= $(shell git describe --always --contains --all)
PMM_RELEASE_FULLCOMMIT ?= $(shell git rev-parse HEAD)
GO_BUILD_LDFLAGS = -X main.version=${COMPONENT_VERSION} -X main.buildDate=${BUILD} -X main.commit=${PMM_RELEASE_FULLCOMMIT} -X main.Branch=${COMPONENT_BRANCH} -X main.GoVersion=${GOVERSION} -s -w
NAME ?= mongodb_exporter
REPO ?= percona/$(NAME)
GORELEASER_FLAGS ?=
UID ?= $(shell id -u)

export TEST_MONGODB_IMAGE?=mongo:4.2
export TEST_MONGODB_ADMIN_USERNAME?=
export TEST_MONGODB_ADMIN_PASSWORD?=
export TEST_MONGODB_USERNAME?=
export TEST_MONGODB_PASSWORD?=
export TEST_MONGODB_S1_RS?=rs1
export TEST_MONGODB_STANDALONE_PORT?=27017
export TEST_MONGODB_S1_PRIMARY_PORT?=17001
export TEST_MONGODB_S1_SECONDARY1_PORT?=17002
export TEST_MONGODB_S1_SECONDARY2_PORT?=17003
export TEST_MONGODB_S1_ARBITER_PORT?=17011
export TEST_MONGODB_S2_RS?=rs2
export TEST_MONGODB_S2_PRIMARY_PORT?=17004
export TEST_MONGODB_S2_SECONDARY1_PORT?=17005
export TEST_MONGODB_S2_SECONDARY2_PORT?=17006
export TEST_MONGODB_S2_ARBITER_PORT?=17012
export TEST_MONGODB_CONFIGSVR_RS?=csReplSet
export TEST_MONGODB_CONFIGSVR1_PORT?=17007
export TEST_MONGODB_CONFIGSVR2_PORT?=17008
export TEST_MONGODB_CONFIGSVR3_PORT?=17009
export TEST_MONGODB_MONGOS_PORT?=17000
export PMM_RELEASE_PATH?=.

define TEST_ENV
	TEST_MONGODB_ADMIN_USERNAME=$(TEST_MONGODB_ADMIN_USERNAME) \
	TEST_MONGODB_ADMIN_PASSWORD=$(TEST_MONGODB_ADMIN_PASSWORD) \
	TEST_MONGODB_USERNAME=$(TEST_MONGODB_USERNAME) \
	TEST_MONGODB_PASSWORD=$(TEST_MONGODB_PASSWORD) \
	TEST_MONGODB_S1_RS=$(TEST_MONGODB_S1_RS) \
	TEST_MONGODB_STANDALONE_PORT=$(TEST_MONGODB_STANDALONE_PORT) \
	TEST_MONGODB_S1_PRIMARY_PORT=$(TEST_MONGODB_S1_PRIMARY_PORT) \
	TEST_MONGODB_S1_SECONDARY1_PORT=$(TEST_MONGODB_S1_SECONDARY1_PORT) \
	TEST_MONGODB_S1_SECONDARY2_PORT=$(TEST_MONGODB_S1_SECONDARY2_PORT) \
	TEST_MONGODB_S1_ARTBITER_PORT=$(TEST_MONGODB_S1_ARBITER_PORT) \
	TEST_MONGODB_S2_RS=$(TEST_MONGODB_S2_RS) \
	TEST_MONGODB_S2_PRIMARY_PORT=$(TEST_MONGODB_S2_PRIMARY_PORT) \
	TEST_MONGODB_S2_SECONDARY1_PORT=$(TEST_MONGODB_S2_SECONDARY1_PORT) \
	TEST_MONGODB_S2_SECONDARY2_PORT=$(TEST_MONGODB_S2_SECONDARY2_PORT) \
	TEST_MONGODB_S2_ARTBITER_PORT=$(TEST_MONGODB_S2_ARBITER_PORT) \
	TEST_MONGODB_CONFIGSVR_RS=$(TEST_MONGODB_CONFIGSVR_RS) \
	TEST_MONGODB_CONFIGSVR1_PORT=$(TEST_MONGODB_CONFIGSVR1_PORT) \
	TEST_MONGODB_CONFIGSVR2_PORT=$(TEST_MONGODB_CONFIGSVR2_PORT) \
	TEST_MONGODB_CONFIGSVR3_PORT=$(TEST_MONGODB_CONFIGSVR3_PORT) \
	TEST_MONGODB_MONGOS_PORT=$(TEST_MONGODB_MONGOS_PORT) \
	TEST_MONGODB_IMAGE=$(TEST_MONGODB_IMAGE)
endef

env:
	@echo $(TEST_ENV) | tr ' ' '\n' >.env

init:                       ## Install linters.
	cd tools && go generate -x -tags=tools

build:                      ## Compile using plain go build
	go build -ldflags="$(GO_BUILD_LDFLAGS)"  -o $(PMM_RELEASE_PATH)/mongodb_exporter

release:                      ## Build the binaries using goreleaser
	docker run --rm --privileged \
		-v ${PWD}:/go/src/github.com/user/repo \
		-w /go/src/github.com/user/repo \
		goreleaser/goreleaser release --snapshot --skip-publish --rm-dist 

FILES = $(shell find . -type f -name '*.go' -not -path "./vendor/*")

format:                     ## Format source code.
	go mod tidy
	bin/gofumpt -l -w $(FILES)
	bin/gci write --section Standard --section Default --section "Prefix(github.com/percona/mongodb_exporter)" .

check:                      ## Run checks/linters
	bin/golangci-lint run

check-license:              ## Check license in headers.
	@go run .github/check-license.go

help:                       ## Display this help message.
	@echo "Please use \`make <target>\` where <target> is one of:"
	@grep '^[a-zA-Z]' $(MAKEFILE_LIST) | \
	awk -F ':.*?## ' 'NF==2 {printf "  %-26s%s\n", $$1, $$2}'

test: env                   ## Run all tests.
	go test -v -count 1 -timeout 30s ./...

test-race: env              ## Run all tests with race flag.
	go test -race -v -timeout 30s ./...

test-cluster: env           ## Starts MongoDB test cluster. Use env var TEST_MONGODB_IMAGE to set flavor and version. Example: TEST_MONGODB_IMAGE=mongo:3.6 make test-cluster
	docker-compose up -d

test-cluster-clean: env     ## Stops MongoDB test cluster.
	docker-compose down --remove-orphans
